SystemOrganization addCategory: #'GT-Debugger'!

!StepThroughDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:32'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousThrough! !

!InstructionStream methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/29/2013 20:29'!
isInitialnstruction

	^ self pc = self method initialPC! !

!Process methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:51'!
stepUntil: aPredicate from: aContext
	"Resume self until the top context safisfy the given condition."

	| ctxt  |
	
	ctxt := aContext.
	[ 
		ctxt notNil and: [aPredicate matches: ctxt]
	] whileFalse: [
		ctxt := self step: ctxt.
	].
	^ ctxt! !

!DebugContext methodsFor: '*gt-debugger' stamp: 'AndreiChis 6/5/2013 14:53'!
gtDebuggerRetrieveVariableValuePairs
	|fieldList|

	fieldList := OrderedCollection new.
	fieldList 
		add: ('_self' ->  context receiver);
	      addAll: (context receiver class allInstVarNames collect: [:each | each -> (context receiver instVarNamed: each) ]).
	
	fieldList add: ('_thisContext' ->  context).
	 context == nil ifTrue: [^fieldList].
	fieldList 
		add: ('_stack top' -> ( context stackPtr > 0 ifTrue: [ context top])).
		
	(context tempNames size > 0) ifTrue: [
		fieldList addAll: ((1 to: context tempNames size) collect: [ :index || key value |
			key := context tempNames at: index.
			value := [context debuggerMap namedTempAt: index in: context] 
				on: Error 
				do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
			key -> value ] ) ].
	
	^ fieldList! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:40'!
createPredicateForBlock: aBlock 

	^ BlockContextPredicate for: aBlock! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/14/2013 18:17'!
createStepPredicateForBlock: aBlock 

	^ self createStepPredicatForPredicate: (self createPredicatForBlock: aBlock)
			! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 16:46'!
createStepPredicateForPredicate: aPredicate
	" Subclasses should specialize this method if needed. "
	^ aPredicate! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 17:22'!
createStepPredicateForPredicate: aPredicate fromContext: targetContext

	^ (self createPredicateForBlock: [ :currentContext |
		(self isActive: targetContext) not or: [ currentContext isHaltContext ] ]) 
			or: aPredicate
	! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/14/2013 18:21'!
isActive: aContext

	^ true! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:51'!
stepUntil: aPredicate from: aContext 
	| ctxt |
	
	ctxt := self process stepUntil: (self createStepPredicateForPredicate: aPredicate) from: aContext.
	self  
		updateWithContext: ctxt 
		fromProcess: self process.! !

!ResumeDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:27'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousPlay! !

!SubclassResponsabilityDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:48'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousAdd! !

!StepIntoDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:31'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousInto! !

!RestartDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:34'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousRestart! !

!DebugAction methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/27/2013 11:43'!
asGlamourAction

	^ ((GLMGenericAction new) 
			action: [ self execute ]; 
			icon: self icon;
			title: self label;
			category: self category;
			yourself)! !

DebugAction subclass: #GTBrowseMethodDebuggerAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTBrowseMethodDebuggerAction class methodsFor: 'registration' stamp: 'TudorGirba 11/16/2013 08:24'!
gtActionFor: aDebugger
	<gtCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousBrowse! !

!GTBrowseMethodDebuggerAction methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2013 08:15'!
defaultLabel

	^ 'Browse'! !

!GTBrowseMethodDebuggerAction methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2013 08:13'!
defaultOrder

	^ 200! !

!GTBrowseMethodDebuggerAction methodsFor: 'actions' stamp: 'TudorGirba 11/16/2013 11:28'!
executeAction
	Smalltalk tools browser 
	fullOnClass: self debugger selectedContext methodClass
 	selector: self debugger selectedContext selector! !

!GTBrowseMethodDebuggerAction methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2013 08:14'!
id

	^ #gtBrowseMethodDebuggerAction! !

DebugAction subclass: #GTTemporaryPreDebugChangeDebuggerAction
	instanceVariableNames: 'preDebugWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTTemporaryPreDebugChangeDebuggerAction class methodsFor: 'registration' stamp: 'AndreiChis 11/13/2013 23:09'!
actionType
	<preDebuggingAction>! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
defaultLabel

	^ 'Debug Glamorously'! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
defaultOrder

	^ 200! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'actions' stamp: 'AndreiChis 11/13/2013 23:23'!
executeAction
	| currentDebugger currentSession |
	
	"Close the spec PreDebugWindow and debugger"
	currentDebugger := self preDebugWindow debugger.
	self preDebugWindow debugger: nil.
	self preDebugWindow close.
	currentSession := currentDebugger session.
	currentDebugger session: nil.
	currentDebugger clear. "clear not close, as at this point there is no open window to close"
	
	GTDebugger debugSession: currentSession! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
id

	^ #gtChangeDebuggerPreDebug! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:59'!
preDebugWindow
	
	^ preDebugWindow! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:59'!
preDebugWindow: anObject
	
	preDebugWindow := anObject! !

!DoesNotUnderstandDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:47'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousAdd! !

!MethodContext methodsFor: '*GT-Debugger' stamp: 'AndreiChis 8/26/2013 16:14'!
gtDebuggerRetrieveVariableValuePairs
	|fieldList context|

	fieldList := OrderedCollection new.
	context := self.
	fieldList 
		add: ('_self' ->  context receiver);
	      addAll: (context receiver class allInstVarNames collect: [:each | each -> (context receiver instVarNamed: each) ]).
	
	fieldList add: ('_thisContext' ->  context).
	 context == nil ifTrue: [^fieldList].
	fieldList 
		add: ('_stack top' -> ( context stackPtr > 0 ifTrue: [ context top])).
		
	(context tempNames size > 0) ifTrue: [
		fieldList addAll: ((1 to: context tempNames size) collect: [ :index || key value |
			key := context tempNames at: index.
			value := [context debuggerMap namedTempAt: index in: context] 
				on: Error 
				do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
			key -> value ] ) ].
	
	^ fieldList! !

WhereIsDebugAction subclass: #GTWhereIsDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTWhereIsDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 11/13/2013 23:40'!
gtActionFor: aDebugger
	<gtCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousSearch! !

!GTWhereIsDebugAction methodsFor: 'actions' stamp: 'AndreiChis 11/13/2013 23:39'!
executeAction

	self debugger updateSelectionInterval! !

!GTWhereIsDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 23:39'!
id

	^ #gtWhereIs! !

GLMCompositePresentation subclass: #GTDebugger
	instanceVariableNames: ''
	classVariableNames: 'AlwaysOpenFullDebugger ErrorRecursion FilterCommonMessageSends LogDebuggerStackToFile LogFileName'
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebugger commentStamp: '<historical>' prior: 0!
GTDebugger is a browser that provides Smalltalk debugging functionality.
 
An example: 
[ GTDebugger debugProcess: Processor activeProcess.
	Processor activeProcess suspend.
	#(1 2 3 4 5) do: [:each | each asString]
] fork.!

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:26'!
alwaysOpenFullDebugger
	^ AlwaysOpenFullDebugger ifNil: [AlwaysOpenFullDebugger := false]! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:26'!
alwaysOpenFullDebugger: aBoolean
	AlwaysOpenFullDebugger := aBoolean.! !

!GTDebugger class methodsFor: 'utilities api' stamp: 'AndreiChis 11/14/2013 22:22'!
closeAllDebuggers
	"SpecDebugger closeAllDebuggers"
	(SystemWindow allSubInstances select: [:w | 
		(w model isKindOf: WindowModel) and: [ 
			w model model isKindOf: self ]  ])
			do: [:w | w delete ]! !

!GTDebugger class methodsFor: 'instance creation api' stamp: 'AndreiChis 11/14/2013 22:17'!
context: aContext
	"Answer an instance of me for debugging the active process starting with the given context."

	^ self new
		process: Processor activeProcess
		controller: nil
		context: aContext
		! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 4/2/2013 14:49'!
debugBasedOnSession: aSession

	^ self debugSession: ((self spanNewSessionForContext: aSession context fromProcess: aSession process)
		errorWasInUIProcess: aSession errorWasInUIProcess)! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:39'!
debugContext: aContext fromProcess: aProcess

	^ self debugSession: (self spanNewSessionForContext: aContext fromProcess: aProcess)! !

!GTDebugger class methodsFor: 'instance creation api' stamp: 'AndreiChis 11/14/2013 22:18'!
debugError: anError
	"Handle an otherwise unhandled error"

	self
		openOn: Processor activeProcess
		context: anError signalerContext
		label: anError description
		contents: nil
		fullView: false! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:39'!
debugSession: aSession

	<primitive: 19> "simulation guard"

	"WorldState addDeferredUIMessage: ["
		^ self openOn: aSession 
	"]"! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:26'!
defaultLogFileName
	^ 'PharoDebug.log'! !

!GTDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 3/26/2013 15:33'!
defaultTitle
	^ 'Glamorous Debugger'! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:40'!
filterCommonMessageSends
	self flag: 'horrible hack not to break the setting browser'.
	^ false! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:26'!
filterCommonMessageSends: aBoolean
	FilterCommonMessageSends := aBoolean! !

!GTDebugger class methodsFor: 'testing' stamp: 'AndreiChis 3/25/2013 14:42'!
handlesContext: aContext

	^ true! !

!GTDebugger class methodsFor: 'instance creation api' stamp: 'AndreiChis 11/14/2013 22:19'!
informExistingDebugger: aContext label: aString
	"Walking the context chain, we try to find out if we're in a debugger stepping situation.
	If we find the relevant contexts, we must rearrange them so they look just like they would
	if the methods were excuted outside of the debugger."
	| ctx quickStepMethod oldSender baseContext |
	ctx := thisContext.
	quickStepMethod := ContextPart compiledMethodAt: #quickSend:to:with:super:.
	[ctx sender == nil or: [ctx sender method == quickStepMethod]] whileFalse: [ctx := ctx sender].
	ctx sender == nil ifTrue: [^self].
	baseContext := ctx.
	"baseContext is now the context created by the #quickSend... method."
	oldSender := ctx := ctx sender home sender.
	"oldSender is the context which originally sent the #quickSend... method"
	[ctx isNil or: [ctx receiver isKindOf: self]] whileFalse: [ctx := ctx sender].
	ctx ifNil: [^self].
	"ctx is the context of the Debugger method #doStep" self flag: 'this is not true any more'.
	ctx receiver label: aString.
	baseContext swapSender: baseContext sender sender sender.	"remove intervening contexts"
	thisContext swapSender: oldSender.	"make myself return to debugger"
	ErrorRecursion := false.
	^aContext! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:26'!
logDebuggerStackToFile
	^ LogDebuggerStackToFile ifNil: [LogDebuggerStackToFile := true]! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:26'!
logDebuggerStackToFile: aBoolean
	 LogDebuggerStackToFile := aBoolean! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:26'!
logFileName
	^ LogFileName ifNil: [ self defaultLogFileName ] ! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:26'!
logFileName: newName
	LogFileName := newName! !

!GTDebugger class methodsFor: 'opening api' stamp: 'AndreiChis 11/14/2013 22:21'!
openContext: aContext label: aString contents: contentsStringOrNil
	"Open a notifier in response to an error, halt, or notify. A notifier view just shows a short view of the sender stack and provides a menu that lets the user open a full debugger."
	
	<primitive: 19> "Simulation guard"
	ErrorRecursion not & self logDebuggerStackToFile ifTrue:
		[Smalltalk logError: aString inContext: aContext].
	  ErrorRecursion ifTrue:[
               ErrorRecursion := false.
               self primitiveError: aString].
	ErrorRecursion := true.
	
	self informExistingDebugger: aContext label: aString.
	(self context: aContext)
		openNotifierContents: contentsStringOrNil
		label: aString.
	ErrorRecursion := false. 
	Processor activeProcess suspend.
! !

!GTDebugger class methodsFor: 'opening api' stamp: 'AndreiChis 11/14/2013 22:21'!
openInterrupt: aString onProcess: interruptedProcess 
	"Open a notifier in response to an interrupt. An interrupt occurs when
	the user types the interrupt key (cmd-. on Macs, ctrl-c or alt-. on other
	systems) or when the low-space watcher detects that memory is low."
	| debugger |
	<primitive: 19>
	"Simulation guard"
	debugger := self new.
	debugger
		process: interruptedProcess
		controller: nil
		context: interruptedProcess suspendedContext.
	self logDebuggerStackToFile
		ifTrue: [(aString includesSubstring: 'Space')
					& (aString includesSubstring: 'low')
				ifTrue: [Smalltalk
						logError: aString
						inContext: debugger interruptedContext ]].
	^ debugger openNotifierContents: nil label: aString! !

!GTDebugger class methodsFor: 'opening' stamp: 'AndreiChis 11/13/2013 23:21'!
openOn: anObject 
	^ self new openOn: anObject! !

!GTDebugger class methodsFor: 'opening api' stamp: 'AndreiChis 11/14/2013 22:21'!
openOn: process context: context label: title contents: contentsStringOrNil fullView: bool 
	"Open a notifier in response to an error, halt, or notify. A notifier view
	just shows a short view of the sender stack and provides a menu that
	lets the user open a full debugger."
	| fullView |
	fullView := (bool or: [self alwaysOpenFullDebugger]).
	
	Smalltalk tools userManager canDebug ifFalse: [ 
		UIManager default spawnNewProcessIfThisIsUI: process.
		process suspend.
		^ self ].
	
	^ UIManager default 
		openDebuggerOn: process 
		context: context 
		label: title 
		contents: contentsStringOrNil 
		fullView: fullView! !

!GTDebugger class methodsFor: 'window color api' stamp: 'AndreiChis 11/14/2013 22:23'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color lightRed
! !

!GTDebugger class methodsFor: 'tools registry' stamp: 'TudorGirba 11/15/2013 08:00'!
register

	self registerToolsOn: Smalltalk tools.
! !

!GTDebugger class methodsFor: 'tools registry' stamp: 'TudorGirba 11/15/2013 08:02'!
registerExtraToolsOn: registry
	"This adds self in the list of tools that appears in the small debugger"
	registry registerDebugger: self withRank: 3.! !

!GTDebugger class methodsFor: 'tools registry' stamp: 'TudorGirba 11/15/2013 08:01'!
registerToolsOn: registry
	registry register: self as: #debugger.
! !

!GTDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 1/13/2013 20:19'!
sessionClass

	^ DebugSession ! !

!GTDebugger class methodsFor: 'private' stamp: 'AndreiChis 1/15/2013 12:07'!
spanNewSessionForContext: aContext fromProcess: aProcess

	^ self sessionClass process: aProcess context: aContext ! !

!GTDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 11/14/2013 22:40'!
stackWidgetClass
	self flag: 'horrible hack not to break the setting browser'.
	^ self! !

!GTDebugger methodsFor: 'callbacks' stamp: 'AndreiChis 3/27/2013 11:56'!
actOnBrowserClosing: ann
	self session ifNotNil: [ :aSession | aSession terminate ]! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 11/13/2013 23:29'!
actionsForPragmas: aSymbolsCollection

	^ (self allActionsForPragmas: aSymbolsCollection)
				collect: [ :aDebugAction | aDebugAction asGlamourAction ]
! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 11/13/2013 23:23'!
allActionsForPragmas: aSymbolsCollection
	
	^ (self session class 
		debuggingActionsForPragmas: aSymbolsCollection for: self)

	
! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 6/20/2013 14:37'!
browser 

	^ self presentations first! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 6/17/2013 16:31'!
close

	self browser close! !

!GTDebugger methodsFor: 'building actions' stamp: 'TudorGirba 11/16/2013 08:16'!
codeActionsPragmas

	^ #( codeDebuggingAction )! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 11/13/2013 23:19'!
compose
	self title: self debuggerTitle.
	self tabulator with: [:browser | 
		self debuggerStructureIn: browser.
		self debuggerTransmissionsIn: browser ].
	self registerActions.
! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/20/2013 14:41'!
currentContext

	^self selectedContext 
		ifNil: [ self interruptedContext ] 
		ifNotNil:  [ self selectedContext  ]! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 4/1/2013 16:19'!
debug: aContext using: aDebuggerClass
	| currentSession  |
	
	currentSession := self session.
	self detachSession.
	self browser close.
	currentSession updateContextTo: aContext.
	aDebuggerClass debugBasedOnSession: currentSession! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:01'!
debuggerStructureIn: browser
	
	browser
		row: [ :row | 
					row
						column: #stack;
						column: #code ];
		row: #inspector.
		! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 3/26/2013 15:35'!
debuggerTitle
	
	^ self class defaultTitle ! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 9/9/2013 13:42'!
debuggerTransmissionsIn: browser

	browser transmit
		fromOutsideEntityPort;
		to: #stack;
		andShow: [ :composite | self stackIn: composite ].
	browser transmit
		from: #stack port: #entity;
		to: #stack port: #selection;
		when: [ :session | session notNil ];
		transformed: [:session | session context].
	browser transmit
		from: #stack port: #selection;
		to: #code;
		andShow: [ :composite :aContext | self methodCodeIn: composite forContext: aContext ].
	browser transmit
		from: #stack port: #selection;
		to: #inspector;
		andShow: [ :composite | self inspectorIn: composite ] 
! !

!GTDebugger methodsFor: 'building actions' stamp: 'TudorGirba 11/16/2013 08:16'!
debuggingActionsPragmas

	^ #( debuggingAction )! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 7/4/2013 16:54'!
detachSession
	self flag: 'why silent value?'.
	(self browser pane port: #entity) silentValue: nil! !

!GTDebugger methodsFor: 'old api' stamp: 'AndreiChis 3/27/2013 11:59'!
errorWasInUIProcess: aBoolean

	self session errorWasInUIProcess: aBoolean! !

!GTDebugger methodsFor: 'building presentations' stamp: 'TudorGirba 11/15/2013 19:17'!
inspectorIn: composite

	composite custom:
			(GTInspector new first "We use the first actual finder because need to send showFirst: to it"
				noTitle;
				noActions;
				showFirst: [ :a | a custom: GTDebuggerVariablesBrowser new ];
				yourself)
	! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:22'!
installActionsForRootPragmas: aSymbolsCollection in: aPresentation

	aPresentation dynamicActions: [ :presentation |
		self actionsForPragmas: (aSymbolsCollection collect: [ :aSymbol | #gt, aSymbol capitalized ]) ] .
	
	aPresentation dynamicActionsOnSelection: [ :presentation |
		self actionsForPragmas: (aSymbolsCollection collect: [ :aSymbol | #gtContext, aSymbol capitalized ]) ] .! !

!GTDebugger methodsFor: 'building actions' stamp: 'TudorGirba 11/16/2013 08:21'!
installCodeActionsFor: aPresentation
	
	self installActionsForRootPragmas: self codeActionsPragmas in: aPresentation! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:14'!
installDebuggingActionsFor: aPresentation

	self installActionsForRootPragmas: self debuggingActionsPragmas in: aPresentation! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/19/2013 19:07'!
interruptedContext

	^ self session context! !

!GTDebugger methodsFor: 'building presentations' stamp: 'TudorGirba 11/16/2013 00:02'!
methodCodeIn: composite forContext: aContext

	(self methodCodeWidgetIn: composite forContext: aContext)
		initialize: [ :code | 
			code selectionInterval: (self session selectedCodeRangeForContext: self currentContext) ];
		with: [ :code | self installCodeActionsFor: code ]! !

!GTDebugger methodsFor: 'building presentations' stamp: 'TudorGirba 11/16/2013 11:12'!
methodCodeWidgetIn: composite forContext: aContext

	^ composite smalltalkCode
		title: 'Source';
		format: [ aContext sourceCode ];
		smalltalkClass: [  aContext methodClass ];
		doItReceiver: [ aContext receiver ];
		doItContext: [  aContext ]! !

!GTDebugger methodsFor: 'opening' stamp: 'AndreiChis 11/13/2013 22:36'!
openFullNoSuspendLabel: aString
	"TODO: do not ignore the title"
	
	self open.
	self flag: 'why is this necessy here? I took it from the current debugger' 
	"errorWasInUIProcess := UIManager default spawnNewProcessIfThisIsUI: interruptedProcess"! !

!GTDebugger methodsFor: 'opening' stamp: 'AndreiChis 11/14/2013 22:31'!
openNotifierContents: msgString label: label

	self openFullNoSuspendLabel: label! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 14:21'!
printStackEntry: aContext

	^ String streamContents: [:stream | aContext printDebugOn: stream ] ! !

!GTDebugger methodsFor: 'old api' stamp: 'AndreiChis 11/14/2013 22:35'!
proceed: aTopView 
	
	self session 
		resume;
		clear.
	self debugger close.
	self updateBrowser
! !

!GTDebugger methodsFor: 'intialization' stamp: 'AndreiChis 3/27/2013 12:00'!
process: aProcess controller: aController context: aContext

	self session: (self class spanNewSessionForContext: aContext fromProcess: aProcess)! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 7/4/2013 15:36'!
registerActions

	self on: GLMBrowserClosing send: #actOnBrowserClosing: to: self.
	self on: DebugActionExecuted send: #updateBrowser to: self.
! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/20/2013 14:37'!
selectedContext

	^ ((self browser paneNamed: #stack) port: #selection) value! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/12/2013 18:13'!
selectionInterval

	^ self selectionIntervalForPane: #code! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/4/2013 15:37'!
selectionInterval: anInterval

	^ ((self browser paneNamed: #code) port: #selectionInterval) value: anInterval! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/12/2013 18:12'!
selectionIntervalForPane: aSymbol

	^ ((self browser paneNamed: aSymbol) port: #selectionInterval) value ifNil: [ ^ 1 to: 0 ]! !

!GTDebugger methodsFor: 'old api' stamp: 'AndreiChis 11/14/2013 22:35'!
send
	
	self session stepInto: self currentContext.
	self updateBrowser.
! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/4/2013 17:07'!
session
 
	^ (self browser pane port: #entity) value! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2013 11:58'!
session: anObject

	^ (self browser pane port: #entity) value: anObject! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/30/2013 14:46'!
stackIn: composite

	(self stackWidgetIn: composite)
		with: [ :stackWidget | self installDebuggingActionsFor: stackWidget ]! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/30/2013 14:45'!
stackWidgetIn: composite

	^ composite list	
		title: 'Stack';
		showOnly: 50;
		display: #stack;
		format: [ :each | self printStackEntry: each]! !

!GTDebugger methodsFor: 'updating' stamp: 'AndreiChis 9/9/2013 09:25'!
updateBrowser
	| browserPane session |
	
	session := self session.
	browserPane := self browser pane.
	(browserPane port: #entity) silentValue: nil.
	(browserPane port: #entity) value: session.
	browserPane update.! !

!GTDebugger methodsFor: 'updating' stamp: 'AndreiChis 3/27/2013 12:00'!
updateSelectionInterval

	self selectionInterval: (self session pcRangeForContext:  self selectedContext )! !

!GTDebugger methodsFor: 'callbacks' stamp: 'AndreiChis 1/15/2013 15:08'!
windowIsClosing 
	self announce: GLMBrowserClosing new! !

GLMCompositePresentation subclass: #GTDebuggerVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerVariablesBrowser commentStamp: 'TudorGirba 11/2/2012 22:06' prior: 0!
GTDebuggerVariablesBrowser is a special browser that is used in the first pane of the inspector that is embedded in the debugger. Its main intention is to provide a unified list of variables that come from:
- the instance variables of the receiver
- the local variables from the context!

!GTDebuggerVariablesBrowser methodsFor: 'building' stamp: 'TudorGirba 11/16/2013 23:15'!
compose  
	self title: [:each | GTInspector new printObjectAsAnItem: each receiver ].
	self morphicAct: [:anotherComposite | anotherComposite entity receiver browse]
				icon: GLMUIThemeExtraIcons glamorousBrowse 
				entitled: 'Browse'.
	self tabulator with: [:browser | 
		browser row: #variables.
		browser transmit to: #variables; andShow: [:a | 
			self variablesIn: a ].
		browser transmit from: #variables; toOutsidePort: #selection.
		"browser transmit from: #variables; toWatcher; andShow: [ :a :object | 
			a custom: (GTInspector new startOn: object) ]" ]! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 11/16/2013 11:24'!
evaluatorIn: composite
	(composite smalltalkCode)
		doItReceiver: [ :methodContext | methodContext receiver ] ;
		display: [ :methodContext | methodContext receiver ];
		format: [ :receiver | 
			[receiver printString asSmalltalkComment, String cr, 'self'] 
				on: Error 
				do: ['"Error printing. Try self printString to debug"'] ];
		selectionPopulate: #selection
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text | 
				Compiler evaluate: text selectedText for: text displayValue logged: false ]! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 8/26/2013 16:15'!
variablesIn: composite
	composite table
		showOnly: 50;
		display: [ :context | context gtDebuggerRetrieveVariableValuePairs ];
		sorted: [:variablePair1 :variablePair2 | variablePair1 key < variablePair2 key];
		column: 'Variable' evaluated: [:assoc | 
			[ Text fromString: assoc key asString ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
		column: 'Value' evaluated: [:assoc | 
			[ Text fromString: (assoc value printString contractTo: 50) ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
"		icon: [ :each |
			each value class theNonMetaClass browserIcon
				ifNotNil: [ OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ] ];"
		send: #value;
		morphicSelectionAct: [:each | each value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse'! !

!SaveDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:42'!
gtActionFor: aDebugger
	<gtCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousAccept! !

!SaveDebugAction methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/18/2013 17:23'!
asGlamourAction

	^ super asGlamourAction
			action: [ :textPresentation | 
				self sourceCode: textPresentation text.
				self execute ]! !

!RunToSelectionDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:46'!
gtActionFor: aDebugger
	"<gtCodeDebuggingAction>"
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousPlay! !

!StepOverDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:32'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousOver! !

!ChangeDebuggerAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 7/14/2013 23:49'!
gtChangeDebuggerActionsFor: aDebugger
	<gtDebuggingAction>
	
	^ self 
		changeDebuggerActionsForContext: aDebugger interruptedContext 
		excluding: aDebugger! !

!ContextPart methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 17:20'!
isHaltContext

	^ self method selector = #halt! !
